From 36c2141b7406e8752199cb77309bb74a78f61f5e Mon Sep 17 00:00:00 2001
From: Daniel Mierswa <impulze@impulze.org>
Date: Thu, 28 Jan 2010 10:25:32 +0100
Subject: [PATCH 05/10] Add macro to check compiler flags.


Signed-off-by: Daniel Mierswa <impulze@impulze.org>
---
 configure.ac       |  294 +++++++++++++++++-----------------------------------
 m4/vlc_common.m4   |    8 ++
 m4/vlc_compiler.m4 |   73 +++++++++++++
 3 files changed, 174 insertions(+), 201 deletions(-)
 create mode 100644 m4/vlc_common.m4
 create mode 100644 m4/vlc_compiler.m4

diff --git a/configure.ac b/configure.ac
index d54e59d..6368eed 100644
--- a/configure.ac
+++ b/configure.ac
@@ -119,21 +119,16 @@ AS_IF([VLC_FEATURE_ENABLED([contrib])], [
     AC_MSG_RESULT([yes])
     AC_SUBST(CONTRIB_DIR)
     export PATH=${CONTRIB_DIR}/bin:$PATH
-    CPPFLAGS="${CPPFLAGS} -I${CONTRIB_DIR}/include"
-    CPPFLAGS_save="${CPPFLAGS_save} -I${CONTRIB_DIR}/include"
-    CFLAGS="${CFLAGS} -I${CONTRIB_DIR}/include"
-    CFLAGS_save="${CFLAGS_save} -I${CONTRIB_DIR}/include"
-    CXXFLAGS="${CXXFLAGS} -I${CONTRIB_DIR}/include"
-    CXXFLAGS_save="${CXXFLAGS_save} -I${CONTRIB_DIR}/include"
-    OBJCFLAGS="${OBJCFLAGS} -I${CONTRIB_DIR}/include"
-    OBJCFLAGS_save="${OBJCFLAGS_save} -I${CONTRIB_DIR}/include"
+    APPEND_CPPFLAGS([-I${CONTRIB_DIR}/include])
+    APPEND_CFLAGS([-I${CONTRIB_DIR}/include])
+    APPEND_CXXFLAGS([-I${CONTRIB_DIR}/include])
+    APPEND_OBJCFLAGS([-I${CONTRIB_DIR}/include])
+    APPEND_LDFLAGS([-L${CONTRIB_DIR}/lib])
     if test $build = $host -o "$PKG_CONFIG_LIBDIR"; then
         export PKG_CONFIG_PATH=${CONTRIB_DIR}/lib/pkgconfig:$PKG_CONFIG_PATH
     else
         export PKG_CONFIG_LIBDIR=${CONTRIB_DIR}/lib/pkgconfig
     fi
-    LDFLAGS="${LDFLAGS} -L${CONTRIB_DIR}/lib"
-    LDFLAGS_save="${LDFLAGS_save} -L${CONTRIB_DIR}/lib"
 
     have_contrib_libs="yes"
 
@@ -162,31 +157,27 @@ VLC_CHECK_SYS()
 VLC_FEATURE_DEFAULT_DISABLE([peflags])
 AS_CASE(["${SYS}"], 
   [bsdi], [
-    CFLAGS_save="${CFLAGS_save} -pthread"; CFLAGS="${CFLAGS_save}"
+    APPEND_CFLAGS([-pthread])
     VLC_ADD_LIBS([dvd dvdcss vcd cdda vcdx],[-ldvd])
   ],
   [bsd], [
-    CFLAGS_save="${CFLAGS_save} -pthread"; CFLAGS="${CFLAGS_save}"
+    APPEND_CFLAGS([-pthread])
     AS_CASE(["${host_os}"],
       [freebsd*], [
-        CPPFLAGS_save="${CPPFLAGS_save} -I/usr/local/include"
-        CPPFLAGS="${CPPFLAGS_save}"
-        LDFLAGS_save="${LDFLAGS_save} -L/usr/local/lib"
-        LDFLAGS="${LDFLAGS_save}"
+        APPEND_CPPFLAGS([-I/usr/local/include])
+        APPEND_LDFLAGS([-L/usr/local/lib])
       ],
       [openbsd*], [
-        CPPFLAGS_save="${CPPFLAGS_save} -I/usr/local/include -I/usr/X11R6/include"
-        CPPFLAGS="${CPPFLAGS_save}"
-        LDFLAGS_save="${LDFLAGS_save} -L/usr/local/lib -L/usr/X11R6/lib/"
-        LDFLAGS="${LDFLAGS_save}"
+        APPEND_CPPFLAGS([-I/usr/local/include -I/usr/X11R6/include])
+        APPEND_LDFLAGS([-L/usr/local/include -L/usr/X11R6/lib])
       ]
     )
   ],
   [darwin], [
-    CFLAGS_save="${CFLAGS_save} -D_INTL_REDIRECT_MACROS"; CFLAGS="${CFLAGS_save}"
-    CXXFLAGS_save="${CXXFLAGS_save} -D_INTL_REDIRECT_MACROS"; CXXFLAGS="${CXXFLAGS_save}"
-    OBJCFLAGS_save="${OBJCFLAGS_save} -D_INTL_REDIRECT_MACROS -std=gnu99"; OBJCFLAGS="${OBJCFLAGS_save}"
-    LDFLAGS_save="${LDFLAGS_save} -Wl,-headerpad_max_install_names"; LDFLAGS="${LDFLAGS_save}"
+    APPEND_CFLAGS([-D_INTL_REDIRECT_MACROS])
+    APPEND_CXXFLAGS([-D_INTL_REDIRECT_MACROS])
+    APPEND_OBJCFLAGS([-D_INTL_REDIRECT_MACROS])
+    APPEND_LDFLAGS([-Wl,-headerpad_max_install_names])
     VLC_ADD_LDFLAGS([mkv mp4 motion], [-Wl,-framework,IOKit,-framework,CoreFoundation])
     VLC_ADD_LDFLAGS([libvlc vlc],[-Wl,-undefined,dynamic_lookup])
     VLC_ADD_LDFLAGS([avcodec avformat access_avio swscale postproc i420_rgb_mmx x264],[-Wl,-read_only_relocs,suppress])
@@ -235,9 +226,9 @@ AS_CASE(["${SYS}"],
         CXX="${CXX} -mmacosx-version-min=${vlc_string_macosx_version_min}"
         OBJC="${OBJC} -mmacosx-version-min=${vlc_string_macosx_version_min}"
         LD="${LD} -macosx_version_min=${vlc_string_macosx_version_min}"
-        CFLAGS_save="${CFLAGS_save} -DMACOSX_DEPLOYMENT_TARGET=${vlc_string_macosx_version_min}"; CFLAGS="${CFLAGS_save}"
-        CXXFLAGS_save="${CXXFLAGS_save} -DMACOSX_DEPLOYMENT_TARGET=${vlc_string_macosx_version_min}"; CXXFLAGS="${CXXFLAGS_save}"
-        OBJCFLAGS_save="${OBJCFLAGS_save} -DMACOSX_DEPLOYMENT_TARGET=${vlc_string_macosx_version_min}"; OBJCFLAGS="${OBJCFLAGS_save}"
+        APPEND_CFLAGS([-DMACOSX_DEPLOYMENT_TARGET=${use_macosx_version_min}])
+        APPEND_CXXFLAGS([-DMACOSX_DEPLOYMENT_TARGET=${use_macosx_version_min}])
+        APPEND_OBJCFLAGS([-DMACOSX_DEPLOYMENT_TARGET=${use_macosx_version_min}])
         MACOSX_DEPLOYMENT_TARGET=${vlc_string_macosx_version_min}
         export MACOSX_DEPLOYMENT_TARGET
     ])
@@ -263,13 +254,13 @@ AS_CASE(["${SYS}"],
     VLC_FEATURE_DEFAULT_ENABLE([peflags])
   ],
   [beos], [
-    CFLAGS_save="${CFLAGS_save} -Wno-multichar"; CFLAGS="${CFLAGS_save}"
-    CXXFLAGS_save="${CXXFLAGS_save} -Wno-multichar"; CXXFLAGS="${CXXFLAGS_save}"
+    APPEND_CFLAGS([-Wno-multichar])
+    APPEND_CXXFLAGS([-Wno-multichar])
     VLC_ADD_CXXFLAGS([beos],[])
     VLC_ADD_LIBS([vlc libvlccore logger],[-lbe])
     VLC_ADD_LIBS([dvdnav dvdread],[-ldl])
     VLC_ADD_LIBS([filesystem],[-lpoll])
-    LDFLAGS_save="${LDFLAGS_save} -lintl"; LDFLAGS="${LDFLAGS_save}"
+    APPEND_LDFLAGS([-lintl])
     dnl Check for BONE
     if test -f /boot/beos/system/lib/libbind.so; then
         VLC_ADD_LIBS([filesystem access_ftp access_mms access_output_udp oldtelnet netsync sap libvlccore growl_udp],[-lbind -lsocket])
@@ -356,58 +347,18 @@ AS_IF([test "${SYS}" = "mingw32" -o "${SYS}" = "mingwce"], [
         AC_MSG_ERROR([LibVLC requires mingw-runtime version 3.15 or higher!])
 ])
     dnl force use of mingw provided c99 *printf over msvcrt
-    CPPFLAGS="${CPPFLAGS} -D__USE_MINGW_ANSI_STDIO=1"
-    CPPFLAGS_save="${CPPFLAGS_save} -D__USE_MINGW_ANSI_STDIO=1"
+    APPEND_CPPFLAGS([-D__USE_MINGW_ANSI_STDIO=1])
 ])
 
-dnl Check for the need to include the mingwex lib for mingw32
-if test "${SYS}" = "mingw32"
-then
-    AC_CHECK_LIB(mingwex,opendir,
-        AC_CHECK_LIB(mingw32,opendir,,
-            [VLC_ADD_LIBS([libvlccore],[-lmingwex])])
-    )
-fi
-
-dnl Check for fnative-struct or mms-bitfields support for mingw32
 if test "${SYS}" = "mingw32"
 then
-    AC_CACHE_CHECK([if \$CC accepts -mms-bitfields],
-        [ac_cv_c_mms_bitfields],
-        [CFLAGS="${CFLAGS_save} -mms-bitfields"
-         AC_TRY_COMPILE([],,ac_cv_c_mms_bitfields=yes, ac_cv_c_mms_bitfields=no)])
-    if test "${ac_cv_c_mms_bitfields}" != "no"; then
-        CFLAGS_save="${CFLAGS_save} -mms-bitfields";
-        CXXFLAGS_save="${CXXFLAGS_save} -mms-bitfields";
-    else
-        AC_CACHE_CHECK([if \$CC accepts -fnative-struct],
-            [ac_cv_c_fnative_struct],
-            [CFLAGS="${CFLAGS_save} -fnative-struct"
-             AC_TRY_COMPILE([],,ac_cv_c_fnative_struct=yes, ac_cv_c_fnative_struct=no)])
-        if test "${ac_cv_c_fnative_struct}" != "no"; then
-            CFLAGS_save="${CFLAGS_save} -fnative-struct";
-            CXXFLAGS_save="${CXXFLAGS_save} -fnative-struct";
-        fi
-    fi
-
-    CFLAGS="${CFLAGS_save}"; CXXFLAGS="${CXXFLAGS_save}"
-fi
-
-dnl Check for fvtable-thunks support for mingw32
-if test "${SYS}" = "mingw32" -a "${CXX}" != ""
-then
-AC_LANG_PUSH(C++)
-    AC_CACHE_CHECK([if \$CXX accepts -fvtable-thunks],
-        [ac_cv_cxx_fvtable_thunks],
-        [CXXFLAGS="${CXXFLAGS_save} -Wall -Werror -fvtable-thunks"
-         AC_TRY_COMPILE([],,ac_cv_cxx_fvtable_thunks=yes,
-                        ac_cv_cxx_fvtable_thunks=no)])
-    if test "${ac_cv_cxx_fvtable_thunks}" = "yes"; then
-        CXXFLAGS_mingw32_special="-fvtable-thunks"
-    fi
+  dnl Check for the need to include the mingwex lib for mingw32
+  AC_CHECK_LIB([mingwex], [opendir], [
+    AC_CHECK_LIB([mingw32], [opendir],, [
+      VLC_ADD_LIBS([libvlccore],[-lmingwex])
+    ])
+  ])
 
-    CXXFLAGS_save="${CXXFLAGS_save} ${CXXFLAGS_mingw32_special}"; CXXFLAGS="${CXXFLAGS_save}"
-AC_LANG_POP(C++)
 fi
 
 dnl
@@ -903,109 +854,67 @@ AS_IF([VLC_FEATURE_ENABLED([warnings-as-error])], [
 ])
 AC_SUBST(CFLAGS_WERROR)
 
-dnl Check for various optimization flags
-AC_CACHE_CHECK([if \$CC accepts -Os],
-    [ac_cv_c_os],
-    [CFLAGS="${CFLAGS_save} -Os"
-     AC_TRY_COMPILE([],,ac_cv_c_os=yes, ac_cv_c_os=no)])
-if test "${ac_cv_c_os}" != "no"; then
-    CFLAGS_OPTIM_SIZE="${CFLAGS_OPTIM_SIZE} -Os"
-else
-    AC_CACHE_CHECK([if \$CC accepts -O],
-        [ac_cv_c_o],
-        [CFLAGS="${CFLAGS_save} -O"
-         AC_TRY_COMPILE([],,ac_cv_c_o=yes, ac_cv_c_o=no)])
-    if test "${ac_cv_c_o}" != "no"; then
-        if test "${ac_cv_c_o3}" = "no"; then
-            CFLAGS_OPTIM_SIZE="${CFLAGS_OPTIM_SIZE} -O"
-        fi
-    fi
-fi
+dnl
+dnl Check compiler flags
+dnl Only add -O4 and -O3 to CFLAGS_OPTIM_SPEED if debug is disabled
+dnl
+AS_IF([test "x${SYS}" = "xmingw32"], [
+  dnl Check for fnative-struct or mms-bitfields support for mingw32
+  COMPILEFLAG_CHECK([-mms-bitfields],, [
+    APPEND_CFLAGS([-mms-bitfields])
+    APPEND_CXXFLAGS([-mms-bitfields])
+  ], [
+    COMPILEFLAG_CHECK([-fnative-struct],, [
+      APPEND_CFLAGS([-fnative-struct])
+      APPEND_CXXFLAGS([-fnative-struct])
+    ])
+  ])
 
-AC_CACHE_CHECK([if \$CC accepts -O4],
-    [ac_cv_c_o4],
-    [CFLAGS="${CFLAGS_save} -O4"
-     AC_TRY_COMPILE([],,ac_cv_c_o4=yes, ac_cv_c_o4=no)])
-if test "${ac_cv_c_o4}" != "no" && VLC_FEATURE_DISABLED([debug]); then
-    CFLAGS_OPTIM_SPEED="${CFLAGS_OPTIM_SPEED} -O4"
-else
-    AC_CACHE_CHECK([if \$CC accepts -O3],
-        [ac_cv_c_o3],
-        [CFLAGS="${CFLAGS_save} -O3"
-         AC_TRY_COMPILE([],,ac_cv_c_o3=yes, ac_cv_c_o3=no)])
-    if test "${ac_cv_c_o3}" != "no" && VLC_FEATURE_DISABLED([debug]); then
-        CFLAGS_OPTIM_SPEED="${CFLAGS_OPTIM_SPEED} -O3"
-    else
-        AC_CACHE_CHECK([if \$CC accepts -O2],
-            [ac_cv_c_o2],
-            [CFLAGS="${CFLAGS_save} -O2"
-             AC_TRY_COMPILE([],,ac_cv_c_o2=yes, ac_cv_c_o2=no)])
-        if test "${ac_cv_c_o2}" != "no"; then
-            CFLAGS_OPTIM_SPEED="${CFLAGS_OPTIM_SPEED} -O2"
-        else
-            AC_CACHE_CHECK([if \$CC accepts -O],
-                [ac_cv_c_o],
-                [CFLAGS="${CFLAGS_save} -O"
-                 AC_TRY_COMPILE([],,ac_cv_c_o=yes, ac_cv_c_o=no)])
-            if test "${ac_cv_c_o}" != "no"; then
-                CFLAGS_OPTIM_SPEED="${CFLAGS_OPTIM_SPEED} -O"
-            fi
-        fi
-    fi
-fi
+  dnl Check for fvtable-thunks support for mingw32
+  AC_LANG_PUSH([C++])
+  CXXFLAGS="${CXXFLAGS_save} -Wall -Werror"
+  COMPILEFLAG_CHECK([-fvtable-thunks],, [APPEND_CXXFLAGS([-fvtable-thunks])])
+  AC_LANG_POP([C++])
+])
 
-AC_CACHE_CHECK([if \$CC accepts -O0],
-    [ac_cv_c_o0],
-    [CFLAGS="${CFLAGS_save} -O0"
-     AC_TRY_COMPILE([],,ac_cv_c_o0=yes, ac_cv_c_o0=no)])
-if test "${ac_cv_c_o0}" != "no"; then
-    CFLAGS_NOOPTIM="${CFLAGS_NOOPTIM} -O0"
-fi
+COMPILEFLAG_CHECK([-Os],, [APPEND_VAR([CFLAGS_OPTIM_SIZE], [-Os])], [
+  COMPILEFLAG_CHECK([-O],, [APPEND_VAR([CFLAGS_OPTIM_SIZE], [-O])])
+])
 
-dnl Check for -ffast-math
-AC_CACHE_CHECK([if \$CC accepts -ffast-math],
-    [ac_cv_c_fast_math],
-    [CFLAGS="${CFLAGS_save} -ffast-math"
-     AC_TRY_COMPILE([],,ac_cv_c_fast_math=yes, ac_cv_c_fast_math=no)])
-if test "${ac_cv_c_fast_math}" != "no"; then
-    CFLAGS_OPTIM_SPEED="${CFLAGS_OPTIM_SPEED} -ffast-math"
-fi
+AS_IF([VLC_FEATURE_DISABLED([debug])], [
+  COMPILEFLAG_CHECK([-O4],, [APPEND_VAR([CFLAGS_OPTIM_SPEED], [-O4])], [
+    COMPILEFLAG_CHECK([-O3],, [APPEND_VAR([CFLAGS_OPTIM_SPEED], [-O3])])
+  ])
+])
+
+dnl Add -O2 or -O even if debug is enabled
+AS_IF([test "x${ac_cv_compflag__o4}" = "xno" && test "x${ac_cv_compflag__o3}" = "xno"], [
+  COMPILEFLAG_CHECK([-O2],, [APPEND_VAR([CFLAGS_OPTIM_SPEED], [-O2])], [
+    COMPILEFLAG_CHECK([-O],, [APPEND_VAR([CFLAGS_OPTIM_SPEED], [-O])])
+  ])
+])
+
+COMPILEFLAG_CHECK([-O0],, [APPEND_VAR([CFLAGS_NOOPTIM], [-O0])])
+COMPILEFLAG_CHECK([-ffast-math],, [APPEND_VAR([CFLAGS_OPTIM_SPEED], [-ffast-math])])
 
-dnl Check for -funroll-loops
 dnl Disabled on BeOS because BeOS' gcc is buggy and may crash with it
-if test "${SYS}" != "beos"
-then
-  AC_CACHE_CHECK([if \$CC accepts -funroll-loops],
-      [ac_cv_c_unroll_loops],
-      [CFLAGS="${CFLAGS_save} -funroll-loops"
-       AC_TRY_COMPILE([],,ac_cv_c_unroll_loops=yes, ac_cv_c_unroll_loops=no)])
-  if test "${ac_cv_c_unroll_loops}" != "no"; then
-      CFLAGS_OPTIM_SPEED="${CFLAGS_OPTIM_SPEED} -funroll-loops"
-  fi
-fi
+AS_IF([test "x${SYS}" != "xbeos"], [
+  COMPILEFLAG_CHECK([-funroll-loops],, [APPEND_VAR([CFLAGS_OPTIM_SPEED], [-funroll-loops])])
+])
 
-dnl Check for -fomit-frame-pointer
-AC_CACHE_CHECK([if \$CC accepts -fomit-frame-pointer],
-    [ac_cv_c_omit_frame_pointer],
-    [CFLAGS="${CFLAGS_save} -fomit-frame-pointer"
-     AC_TRY_COMPILE([],,ac_cv_c_omit_frame_pointer=yes, ac_cv_c_omit_frame_pointer=no)])
-if test "${ac_cv_c_omit_frame_pointer}" != "no"; then
- if test "${SYS}" != "darwin"; then
-    CFLAGS_OPTIM_NODEBUG="${CFLAGS_OPTIM_NODEBUG} -fomit-frame-pointer"
- else
+COMPILEFLAG_CHECK([-fomit-frame-pointer],, [
+  AS_IF([test "x${SYS}" = "xdarwin"], [
+    APPEND_VAR([CFLAGS_OPTIM_NODEBUG], [-fomit-frame-pointer])
+  ], [
     dnl On darwin we explicitely disable it.
-    CFLAGS_OPTIM_NODEBUG="${CFLAGS_OPTIM_NODEBUG} -fno-omit-frame-pointer"
- fi
-fi
+    APPEND_VAR([CFLAGS_OPTIM_NODEBUG], [-fno-omit-frame-pointer])
+  ])
+])
 
 dnl Check for Darwin plugin linking flags
-AC_CACHE_CHECK([if \$CC accepts -bundle -undefined error],
-    [ac_cv_ld_darwin],
-    [CFLAGS="${CFLAGS_save} -bundle -undefined error"
-     AC_TRY_COMPILE([],,ac_cv_ld_darwin=yes, ac_cv_ld_darwin=no)])
-if test "${ac_cv_ld_darwin}" != "no"; then
-    VLC_ADD_LDFLAGS([plugin],[-bundle -undefined error])
-fi
+COMPILEFLAG_CHECK([-bundle -undefined error],, [
+  VLC_ADD_LDFLAGS([plugin], [-bundle -undefined error])
+])
 
 dnl Checks for __attribute__(aligned()) directive
 AC_CACHE_CHECK([__attribute__ ((aligned ())) support],
@@ -1427,19 +1336,16 @@ AS_IF([VLC_STRING_SET([tuning])], [
 ])
 
 dnl NOTE: this can't be cached cleanly
-AS_IF([test "${CFLAGS_TUNING}"],
-   [CFLAGS_save="${CFLAGS}"
-    CFLAGS="${CFLAGS} ${CFLAGS_TUNING}"
-
-    AC_MSG_CHECKING([whether $CC accepts ${CFLAGS_TUNING}])
-    AC_COMPILE_IFELSE([ ],
-                      [tuning="yes"],
-                      [CFLAGS_TUNING=""; tuning="no"
-                       AS_IF([VLC_STRING_SET([with-tuning])],
-                             [AC_MSG_ERROR([requested tuning not supported])])])
-
-    AC_MSG_RESULT([$tuning])
-    CFLAGS="${CFLAGS_save}"
+AS_IF([test "${CFLAGS_TUNING}"], [
+  CFLAGS="${CFLAGS} ${CFLAGS_TUNING}"
+
+  COMPILEFLAG_CHECK([${CFLAGS_TUNING}], [tuning],, [
+    AS_IF([VLC_STRING_SET([tuning])], [
+      AC_MSG_ERROR([requested tuning not supported])
+    ])
+  ])
+
+  CFLAGS="${CFLAGS_save}"
 ])
 
 dnl
@@ -1492,13 +1398,9 @@ dnl  Test coverage
 dnl
 VLC_FEATURE_OPTION([coverage], [build for test coverage], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([coverage])], [
-	CFLAGS="-fprofile-arcs -ftest-coverage ${CFLAGS}"
-	CXXFLAGS="-fprofile-arcs -ftest-coverage ${CXXFLAGS}"
-	LDFLAGS="-lgcov ${LDFLAGS}"
-	dnl ugly...
-	CFLAGS_save="${CFLAGS}"
-	CXXFLAGS_save="${CXXFLAGS}"
-	LDFLAGS_save="${LDFLAGS}"
+  PREPEND_CFLAGS([-fprofile-arcs -ftest-coverage])
+  PREPEND_CXXFLAGS([-fprofile-arcs -ftest-coverage])
+  PREPEND_LDFLAGS([-lgcov])
 ])
 
 dnl
@@ -1656,7 +1558,6 @@ AS_IF([VLC_FEATURE_ENABLED([live555])], [
   dnl
   AS_IF([{ VLC_STRING_UNSET([live555-tree]) && test "${CXX}" != "" ;}], [
     AC_LANG_PUSH(C++)
-    CPPFLAGS_save="${CPPFLAGS}"
     CPPFLAGS_live555="-I/usr/include/liveMedia -I/usr/include/groupsock -I/usr/include/BasicUsageEnvironment -I/usr/include/UsageEnvironment"
     if test "${SYS}" = "solaris"; then
       CPPFLAGS_live555="${CPPFLAGS_live555} -DSOLARIS"
@@ -2248,8 +2149,6 @@ AS_IF([VLC_FEATURE_ENABLED([screen])], [
   elif test "${SYS}" = "mingw32"; then
     VLC_ADD_PLUGIN([screen])
     VLC_ADD_LIBS([screen],[-lgdi32])
-  elif test "${SYS}" = "mingwce"; then
-    CPPFLAGS="${CPPFLAGS_save}"
   elif test "${SYS}" = "beos"; then
     VLC_ADD_PLUGIN([screen])
     VLC_ADD_CXXFLAGS([screen],[])
@@ -2942,7 +2841,6 @@ AS_IF([VLC_FEATURE_ENABLED([x264])], [
       ],[
         AC_MSG_ERROR([the specified tree hasn't been compiled])
       ])
-      LDFLAGS="${LDFLAGS_save}"
     else
       AC_MSG_RESULT(no)
       AC_MSG_ERROR([the specified tree doesn't have x264.h])
@@ -2971,7 +2869,6 @@ AS_IF([VLC_FEATURE_ENABLED([x264])], [
             AC_MSG_ERROR([Could not find libx264 >= 0.76 on your system: you may get it from http://www.videolan.org/x264.html])
           ])
       ])
-    LDFLAGS="${LDFLAGS_save}"
   ])
 ])
 
@@ -3443,9 +3340,6 @@ AS_IF([VLC_FEATURE_ENABLED([directfb])], [
     LIBS_mydirectfb=
     AS_IF([VLC_STRING_SET([directfb])], [
         dnl Trying the given location
-        CPPFLAGS_save="${CPPFLAGS}"
-        LIBS_save="${LIBS}"
-
         CPPFLAGS_new="-I${vlc_string_directfb}/include -D_REENTRANT -D_GNU_SOURCE"
         LIBS_new="-L${vlc_string_directfb}/lib/fusion/.libs/ -L${vlc_string_directfb}/lib/direct/.libs/"
         LIBS_new="${LIBS_new} -L${vlc_string_directfb}/src/.libs/"
@@ -3646,7 +3540,6 @@ VLC_FEATURE_OPTION([cyberlin], [CyberLink for C++ UPnP stack], [disabled])
       AC_MSG_RESULT(no)
       AC_MSG_ERROR([cannot cd to ${try_cyberlink_tree}])
     ])
-    CPPFLAGS_save="${CPPFLAGS}"
     CPPFLAGS_cyberlink="-I${real_cyberlink_tree}/include"
     CPPFLAGS="${CPPFLAGS} ${CPPFLAGS_cyberlink}"
     AC_CHECK_HEADERS([cybergarage/upnp/MediaServer.h],
@@ -3660,7 +3553,6 @@ VLC_FEATURE_OPTION([cyberlin], [CyberLink for C++ UPnP stack], [disabled])
       AC_MSG_RESULT(${real_cyberlink_tree}/lib/unix/libclink.a)
       dnl The mere fact that we have to make such an ugly check sucks
       AC_MSG_CHECKING(for XML parser to link CyberLink with)
-      LIBS_save="$LIBS"
       LIBS_cclink="no"
       for l in "`xml2-config --libs`" -lexpat -lxerces-c; do
         LIBS="$LIBS_save ${real_cyberlink_tree}/lib/unix/libclink.a -lpthread $l"
diff --git a/m4/vlc_common.m4 b/m4/vlc_common.m4
new file mode 100644
index 0000000..d5da041
--- /dev/null
+++ b/m4/vlc_common.m4
@@ -0,0 +1,8 @@
+dnl Common shell foo.
+
+dnl APPEND_VAR(VARNAME, CONTENTS)
+dnl PREPEND_VAR(VARNAME, CONTENTS)
+dnl
+dnl Append or prepend CONTENTS to shell variable VARNAME.
+AC_DEFUN([APPEND_VAR], [$1][="${][$1][} ][$2]["])
+AC_DEFUN([PREPEND_VAR], [$1][="][$2][ ${]$1[}"])
diff --git a/m4/vlc_compiler.m4 b/m4/vlc_compiler.m4
new file mode 100644
index 0000000..a3dd07b
--- /dev/null
+++ b/m4/vlc_compiler.m4
@@ -0,0 +1,73 @@
+dnl Handling compiler specific things of configure.
+
+dnl APPEND_*FLAGS(FLAGS)
+dnl PREPEND_*FLAGS(FLAGS)
+dnl 
+dnl Append or prepend flags to global *FLAGS (*FLAGS and *FLAGS_save).
+AC_DEFUN([APPEND_CPPFLAGS], [
+  APPEND_VAR([CPPFLAGS_save], [$1])
+  CPPFLAGS="${CPPFLAGS_save}"
+])
+AC_DEFUN([APPEND_CFLAGS], [
+  APPEND_VAR([CFLAGS_save], [$1])
+  CFLAGS="${CFLAGS_save}"
+])
+AC_DEFUN([APPEND_CXXFLAGS], [
+  APPEND_VAR([CXXFLAGS_save], [$1])
+  CXXFLAGS="${CXXFLAGS_save}"
+])
+AC_DEFUN([APPEND_OBJCFLAGS], [
+  APPEND_VAR([OBJCFLAGS_save], [$1])
+  OBJCFLAGS="${OBJCFLAGS_save}"
+])
+AC_DEFUN([APPEND_LDFLAGS], [
+  APPEND_VAR([LDFLAGS_save], [$1])
+  LDFLAGS="${LDFLAGS_save}"
+])
+AC_DEFUN([PREPEND_CPPFLAGS], [
+  PREPEND_VAR([CPPFLAGS_save], [$1])
+  CPPFLAGS="${CPPFLAGS_save}"
+])
+AC_DEFUN([PREPEND_CFLAGS], [
+  PREPEND_VAR([CFLAGS_save], [$1])
+  CFLAGS="${CFLAGS_save}"
+])
+AC_DEFUN([PREPEND_CXXFLAGS], [
+  PREPEND_VAR([CXXFLAGS_save], [$1])
+  CXXFLAGS="${CXXFLAGS_save}"
+])
+AC_DEFUN([PREPEND_OBJCFLAGS], [
+  PREPEND_VAR([OBJCFLAGS_save], [$1])
+  OBJCFLAGS="${OBJCFLAGS_save}"
+])
+AC_DEFUN([PREPEND_LDFLAGS], [
+  PREPEND_VAR([LDFLAGS_save], [$1])
+  LDFLAGS="${LDFLAGS_save}"
+])
+
+dnl COMPILEFLAG_CHECK(FLAGS, [CACHE-VARIABLE-SUFFIX], [ACTION-IF], [ACTION-IF-NOT])
+dnl 
+dnl Check if the compiler understands certain flags. Store yes/no
+dnl in ac_cv_compflags_CACHE-VARIABLE-SUFFIX.
+dnl CACHE-VARIABLE-SUFFIX defaults to lowercase FLAGS with '-' and ' '
+dnl substituted by '_'.
+dnl Restores the original _save flags after compiling.
+AC_DEFUN([COMPILEFLAG_CHECK], [
+  m4_pushdef([cvar],
+             [ac_cv_compflags_]m4_default([$2], m4_tolower(m4_bpatsubst($1, [[- ]], [_]))))
+
+  AC_CACHE_CHECK([if \$CC accepts $1], cvar, [
+    APPEND_VAR([CFLAGS], [$1])
+    APPEND_VAR([CXXFLAGS], [$1])
+    APPEND_VAR([OBJCFLAGS], [$1])
+
+    AC_COMPILE_IFELSE([AC_LANG_PROGRAM()], cvar="yes", cvar="no")
+
+    VLC_RESTORE_FLAGS()
+  ])
+
+  AS_IF([test "x${]cvar[}" = "xyes"], [$3], [$4])
+
+  m4_popdef([cvar])
+])
+
-- 
1.6.6.1


